Debian Bug report logs - #446028
RFP: tg3dfsg -- firmware free Broadcom Tigon3 network driver

Package: wnpp; Maintainer for wnpp is wnpp@debian.org;

Reported by: Robert Edmonds <edmonds@debian.org>

Date: Tue, 9 Oct 2007 22:18:05 UTC

Severity: wishlist

Reply or subscribe to this bug.

Toggle useless messages

View this report as an mbox folder, status mbox, maintainer mbox


Report forwarded to debian-bugs-dist@lists.debian.org, <wnpp@debian.org>, "robert s. edmonds" <edmonds@debian.org>:
Bug#446028; Package wnpp. Full text and rfc822 format available.

Acknowledgement sent to Robert Edmonds <edmonds@debian.org>:
New Bug report received and forwarded. Copy sent to <wnpp@debian.org>, "robert s. edmonds" <edmonds@debian.org>. Full text and rfc822 format available.

Message #5 received at submit@bugs.debian.org (full text, mbox):

From: Robert Edmonds <edmonds@debian.org>
To: submit@bugs.debian.org
Subject: ITP: tg3dfsg -- firmware free Broadcom Tigon3 network driver
Date: Tue, 9 Oct 2007 18:15:24 -0400
[Message part 1 (text/plain, inline)]
Package: wnpp
Owner: "Robert S. Edmonds" <edmonds@debian.org>
Severity: wishlist

* Package name    : tg3dfsg
  Version         : 3.81
  Upstream Author : Various
* URL             : http://people.debian.org/~edmonds/tg3dfsg/
* License         : GPLv2
  Programming Lang: C
  Description     : firmware free Broadcom Tigon3 network driver

 This package provides the source code for the tg3dfsg kernel
 module.  Kernel source or headers are required to compile this module.

This driver complies with GR 2006-004 and should support all Tigon3
hardware except for 5701a0 chipsets.  I intend to upload it should
linux kernel images be uploaded which lack the tg3 driver.

-- 
Robert Edmonds
edmonds@debian.org
[signature.asc (application/pgp-signature, inline)]

Information forwarded to debian-bugs-dist@lists.debian.org, <wnpp@debian.org>, "robert s. edmonds" <edmonds@debian.org>:
Bug#446028; Package wnpp. Full text and rfc822 format available.

Acknowledgement sent to Robert Edmonds <edmonds@debian.org>:
Extra info received and forwarded to list. Copy sent to <wnpp@debian.org>, "robert s. edmonds" <edmonds@debian.org>. Full text and rfc822 format available.

Message #10 received at 446028@bugs.debian.org (full text, mbox):

From: Robert Edmonds <edmonds@debian.org>
To: debian-devel@lists.debian.org, 446028@bugs.debian.org
Subject: Re: Bug#446028: ITP: tg3dfsg -- firmware free Broadcom Tigon3 network driver
Date: Wed, 10 Oct 2007 14:16:43 -0400
[Message part 1 (text/plain, inline)]
Faidon Liambotis wrote:
> Robert Edmonds wrote:
>>  This package provides the source code for the tg3dfsg kernel
>>  module.  Kernel source or headers are required to compile this module.
>> 
>> This driver complies with GR 2006-004 and should support all Tigon3
>> hardware except for 5701a0 chipsets.  I intend to upload it should
>> linux kernel images be uploaded which lack the tg3 driver.
> This doesn't sound good.
>
> Any reason why your 5701a0-removal patch can't be applied to our kernel
> packages?
>
> Or even better, why the driver can't be converted to use
> request_firmware() instead of embedding the firmware to the source?

There are three hunks of firmware code in the tg3 driver; the other two
enable TSO on chipsets which lack TSO firmware in silicon, but AFAIK
these chips should function without TSO.  (In fact, TSO has been
disabled in this driver in the past.)

Any modification to the tg3 driver to produce a GR 2006-004 compliant
driver would have to diverge from the kernel team's patch acceptance
guidelines[0] since upstream is intransigent[1] on making tg3
firmware-free or firmware-optional.  The kernel team does not appear to
be interested in maintaining such a driver, and it appears future linux
kernel source packages will be patched[2] to simply remove the blobs of
firmware (I don't know why the driver isn't simply removed entirely
since the result does not compile).

Obviously, since I and many other users have computers with embedded
Tigon3 hardware, I would be delighted if this package were unnecessary.

[0] http://wiki.debian.org/DebianKernelPatchAcceptanceGuidelines
[1] http://article.gmane.org/gmane.linux.debian.devel.kernel/32543/
[2] http://tinyurl.com/36xr2b, http://tinyurl.com/2u2cu5

-- 
Robert Edmonds
edmonds@debian.org
[signature.asc (application/pgp-signature, inline)]

Information forwarded to debian-bugs-dist@lists.debian.org, <wnpp@debian.org>, "robert s. edmonds" <edmonds@debian.org>:
Bug#446028; Package wnpp. Full text and rfc822 format available.

Acknowledgement sent to Faidon Liambotis <paravoid@debian.org>:
Extra info received and forwarded to list. Copy sent to <wnpp@debian.org>, "robert s. edmonds" <edmonds@debian.org>. Full text and rfc822 format available.

Message #15 received at 446028@bugs.debian.org (full text, mbox):

From: Faidon Liambotis <paravoid@debian.org>
To: debian-kernel@lists.debian.org
Cc: debian-devel@lists.debian.org, 446028@bugs.debian.org
Subject: Re: Bug#446028: ITP: tg3dfsg -- firmware free Broadcom Tigon3 network driver
Date: Wed, 10 Oct 2007 21:41:41 +0300
Robert Edmonds wrote:
> Any modification to the tg3 driver to produce a GR 2006-004 compliant
> driver would have to diverge from the kernel team's patch acceptance
> guidelines[0] since upstream is intransigent[1] on making tg3
> firmware-free or firmware-optional.  The kernel team does not appear to
> be interested in maintaining such a driver, and it appears future linux
> kernel source packages will be patched[2] to simply remove the blobs of
> firmware (I don't know why the driver isn't simply removed entirely
> since the result does not compile).
This seems totally inappropriate.

If the driver includes non-free firmwares these should be removed or
split up from the driver source, not remove the driver entirely.
If what you say is right, the driver *works* for most of the hardware
without non-free blobs.
Therefore, I can't understand how removing the driver serves our users.

Any rationale behind that decision?
I feel like I'm arguing for something completely obvious...

Regards,
Faidon




Information forwarded to debian-bugs-dist@lists.debian.org, <wnpp@debian.org>, "robert s. edmonds" <edmonds@debian.org>:
Bug#446028; Package wnpp. Full text and rfc822 format available.

Acknowledgement sent to Robert Edmonds <edmonds@debian.org>:
Extra info received and forwarded to list. Copy sent to <wnpp@debian.org>, "robert s. edmonds" <edmonds@debian.org>. Full text and rfc822 format available.

Message #20 received at 446028@bugs.debian.org (full text, mbox):

From: Robert Edmonds <edmonds@debian.org>
To: 446028@bugs.debian.org
Cc: debian-kernel@lists.debian.org, debian-devel@lists.debian.org
Subject: Re: Bug#446028: ITP: tg3dfsg -- firmware free Broadcom Tigon3 network driver
Date: Wed, 10 Oct 2007 14:57:59 -0400
[Message part 1 (text/plain, inline)]
Faidon Liambotis wrote:
> Robert Edmonds wrote:
> > Any modification to the tg3 driver to produce a GR 2006-004 compliant
> > driver would have to diverge from the kernel team's patch acceptance
> > guidelines[0] since upstream is intransigent[1] on making tg3
> > firmware-free or firmware-optional.  The kernel team does not appear to
> > be interested in maintaining such a driver, and it appears future linux
> > kernel source packages will be patched[2] to simply remove the blobs of
> > firmware (I don't know why the driver isn't simply removed entirely
> > since the result does not compile).
> This seems totally inappropriate.
> 
> If the driver includes non-free firmwares these should be removed or
> split up from the driver source, not remove the driver entirely.
> If what you say is right, the driver *works* for most of the hardware
> without non-free blobs.
> Therefore, I can't understand how removing the driver serves our users.

That is why I said "appear", since I hope that the kernel team has plans
for the driver beyond simply eliding it.

(I'd like to point out that the equivalent FreeBSD if_bge driver has no
firmware blobs.)

> Any rationale behind that decision?
> I feel like I'm arguing for something completely obvious...

The only rationale for removing the *firmware* is compliance with GR
2006-004...

-- 
Robert Edmonds
edmonds@debian.org
[signature.asc (application/pgp-signature, inline)]

Information forwarded to debian-bugs-dist@lists.debian.org, <wnpp@debian.org>, "robert s. edmonds" <edmonds@debian.org>:
Bug#446028; Package wnpp. Full text and rfc822 format available.

Acknowledgement sent to Per Olofsson <pelle@dsv.su.se>:
Extra info received and forwarded to list. Copy sent to <wnpp@debian.org>, "robert s. edmonds" <edmonds@debian.org>. Full text and rfc822 format available.

Message #25 received at 446028@bugs.debian.org (full text, mbox):

From: Per Olofsson <pelle@dsv.su.se>
To: 446028@bugs.debian.org
Cc: debian-kernel@lists.debian.org, debian-devel@lists.debian.org
Subject: Re: Bug#446028: ITP: tg3dfsg -- firmware free Broadcom Tigon3 network driver
Date: Thu, 11 Oct 2007 09:42:00 +0200
Hi,

Robert Edmonds wrote:
> The only rationale for removing the *firmware* is compliance with GR
> 2006-004...

Am I missing something here? Didn't that GR fail?

http://www.debian.org/vote/2006/vote_004

-- 
Pelle




Information forwarded to debian-bugs-dist@lists.debian.org, <wnpp@debian.org>, "robert s. edmonds" <edmonds@debian.org>:
Bug#446028; Package wnpp. Full text and rfc822 format available.

Acknowledgement sent to Ben Hutchings <ben@decadent.org.uk>:
Extra info received and forwarded to list. Copy sent to <wnpp@debian.org>, "robert s. edmonds" <edmonds@debian.org>. Full text and rfc822 format available.

Message #30 received at 446028@bugs.debian.org (full text, mbox):

From: Ben Hutchings <ben@decadent.org.uk>
To: Per Olofsson <pelle@dsv.su.se>
Cc: 446028@bugs.debian.org, debian-kernel@lists.debian.org, debian-devel@lists.debian.org
Subject: Re: Bug#446028: ITP: tg3dfsg -- firmware free Broadcom Tigon3 network driver
Date: Thu, 11 Oct 2007 12:05:17 +0100
[Message part 1 (text/plain, inline)]
On Thu, 2007-10-11 at 09:42 +0200, Per Olofsson wrote:
> Hi,
> 
> Robert Edmonds wrote:
> > The only rationale for removing the *firmware* is compliance with GR
> > 2006-004...
> 
> Am I missing something here? Didn't that GR fail?
> 
> http://www.debian.org/vote/2006/vote_004

There's no need for a resolution to decide that executable machine code
- whether or not you call it "firmware"[1] - is software.  The relevant
GR is 2006-007, which decided against making a permanent exception for
"firmware" in the kernel.

[1] The term "firmware" should apply only to software that is installed
in non-volatile memory such as ROM or flash, which Debian does not need
to distribute.  What we're talking about here is software for peripheral
processors.

Ben.

-- 
Ben Hutchings
The program is absolutely right; therefore, the computer must be wrong.
[signature.asc (application/pgp-signature, inline)]

Reply sent to David Moreno Garza <damog@merkel.debian.org>:
You have taken responsibility. (Thu, 16 Oct 2008 18:03:29 GMT) Full text and rfc822 format available.

Notification sent to Robert Edmonds <edmonds@debian.org>:
Bug acknowledged by developer. (Thu, 16 Oct 2008 18:03:29 GMT) Full text and rfc822 format available.

Message #35 received at 446028-done@bugs.debian.org (full text, mbox):

From: David Moreno Garza <damog@merkel.debian.org>
To: 446028-done@bugs.debian.org
Subject: WNPP bug closing
Date: Thu, 16 Oct 2008 11:59:34 -0600
Hello,

This is an automatic mail sent to close the ITP you have reported or 
are involved with.

Your ITP wnpp bug is being closed because of the following reasons:
- It is, as of today, older than 365 days.
- It hasn't had any activity recently.

As this is an automatic procedure, it could of course have something
wrong and probably it would be closing some bugs that are not 
intended by owners and submitters (like you) to be closed, for
example if the ITP is still of your interest, or there has been 
some kind of activity around it. In that case, please reopen the
bug, do it, DO IT NOW! (I don't want to be blamed because of
mass closing and not let people know that they can easily reopen
their bugs ;-).

To re-open it, you simply have to mail control@bugs.debian.org
with a body text like this:

 reopen 446028
 stop

Further comments on the work done in the bug sent to
446028@bugs.debian.org would be truly welcomed.
Anyway, if you have any kind of problems when dealing with
the BTS, feel free to contact me and I'd be more than happy to help
you on this: <damog@debian.org>.

A similar process is being applied to other kind of wnpp bugs.

Thanks for your cooperation,

 -- David Moreno Garza <damog@debian.org>.
 




Bug reopened, originator not changed. Request was from Robert S. Edmonds <edmonds@debian.org> to control@bugs.debian.org. (Thu, 16 Oct 2008 18:51:04 GMT) Full text and rfc822 format available.

Information forwarded to debian-bugs-dist@lists.debian.org, <wnpp@debian.org>, "robert s. edmonds" <edmonds@debian.org>:
Bug#446028; Package wnpp. (Thu, 09 Apr 2009 15:51:14 GMT) Full text and rfc822 format available.

Acknowledgement sent to Daniel Knabl <daniel@tirolinux.net>:
Extra info received and forwarded to list. Copy sent to <wnpp@debian.org>, "robert s. edmonds" <edmonds@debian.org>. (Thu, 09 Apr 2009 15:51:32 GMT) Full text and rfc822 format available.

Message #42 received at 446028@bugs.debian.org (full text, mbox):

From: Daniel Knabl <daniel@tirolinux.net>
To: debian-devel@lists.debian.org, 446028@bugs.debian.org
Subject: tg3 firmware - was (Fw: [CASE#221365]: Closed - need firmware files)
Date: Thu, 9 Apr 2009 17:46:58 +0200
[Message part 1 (text/plain, inline)]
Seems to me that Broadcom Inc. does really allow Debian to
re-distribute the included firmware explicitly.

regards
Daniel



Begin forwarded message(s):

Datum: Thu, 9 Apr 2009 05:02:23 -0700
Von: nic_technology_support@broadcom.com
An: daniel@tirolinux.net
Betreff: [CASE#221365]:  Closed - need firmware files


Update Time: Apr  9 2009  5:00AM PST/PDT

Field: Status
Old Value: Resolved
New Value: Closed


-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*
Apr  2 2009  1:21PM PST/PDT
Our Linux driver as a whole is released under GPL license; therefore, I
don't see any issue with re-distributing the driver.

-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*
daniel@tirolinux.net Apr  2 2009 12:00PM PST/PDT
So can you please clarify that to me and especially to the Debian
Maintainers: Is the Debian project allowed to redistribute the firmware
included in your drivers?

Anyway, what would stand against the right to re-distribute firmware
for a product/device that is already property of the customer who
bought it?

kind regards

-- 
Daniel Knabl
www.tirolinux.net             daniel@tirolinux.net
PGP/GPG Fingerprint - please send signed mail only
A069 671B 39F2 E9B9 FB34  68BB 4BEC 1344 C8A4 3F0B

-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*
Apr  2 2009 10:35AM PST/PDT
These micro-codes are embedded into our drivers, we do not provide
these separately.



--- ISSUE SUMMARY ---
Project: NIC Tech
Product: BCM5906
Item: Linux 32
Status: Closed
Requester: Daniel Knabl <daniel@tirolinux.net>
Company: Broadcom Corporation
Req. Priority: Low

Summary: need firmware files

Description: 
Debian does not provide firmware files, because they are not provided
with source code which is necessary because of GPL. please provide the
following firmware: tso-1.4.0, tg3_tso5.bin, tg3_tso.bin, tg3.bin

Operating System: Linux 32
Additional OS Info: Debian Lenny 5.0
System Model: Lenovo 3000 N200
Device Type: On Board
Driver Version: 3.92.1
Ethernet Controller: BCM5906



---
To view attachments for this case click on this link: 
https://support.broadcom.com/IMS/Public/IssueAttachments.aspx?IssueId=221365&AccessCode=399025034807870400000
---


---
INSTRUCTIONS: To update this case, reply to this email maintaining the
full Case ID [including square parentheses] in the subject field. To
avoid cluttering the "Notes" field, please delete the original message
text before sending your reply.

Original MailTo: daniel@tirolinux.net



-- 
Daniel Knabl
www.tirolinux.net             daniel@tirolinux.net
PGP/GPG Fingerprint - please send signed mail only
A069 671B 39F2 E9B9 FB34  68BB 4BEC 1344 C8A4 3F0B
[signature.asc (application/pgp-signature, attachment)]

Information forwarded to debian-bugs-dist@lists.debian.org, <wnpp@debian.org>, "robert s. edmonds" <edmonds@debian.org>:
Bug#446028; Package wnpp. (Thu, 09 Apr 2009 20:42:02 GMT) Full text and rfc822 format available.

Acknowledgement sent to "brian m. carlson" <sandals@crustytoothpaste.ath.cx>:
Extra info received and forwarded to list. Copy sent to <wnpp@debian.org>, "robert s. edmonds" <edmonds@debian.org>. (Thu, 09 Apr 2009 20:42:02 GMT) Full text and rfc822 format available.

Message #47 received at 446028@bugs.debian.org (full text, mbox):

From: "brian m. carlson" <sandals@crustytoothpaste.ath.cx>
To: debian-devel@lists.debian.org, 446028@bugs.debian.org, debian-legal@lists.debian.org
Subject: Re: tg3 firmware - was (Fw: [CASE#221365]: Closed - need firmware files)
Date: Thu, 9 Apr 2009 20:41:12 +0000
[Message part 1 (text/plain, inline)]
[CC'd -legal as well; you probably want to follow up there.]

On Thu, Apr 09, 2009 at 05:46:58PM +0200, Daniel Knabl wrote:
>Seems to me that Broadcom Inc. does really allow Debian to
>re-distribute the included firmware explicitly.

The GPLv2 requires that distributors provide source code in certain
circumstances.  Source code is defined in the GPLv2 as the preferred
form for modification.  Unless Broadcom uses a hex editor to modify the
firmware, Debian does not have the source code (the preferred form for
modification) and therefore cannot provide it upon request.  Since
Debian cannot comply with the license, it is not permitted to distribute
it at all.  Doing so would be copyright infringement.

If Broadcom were to license the firmware under a revised BSD license or
another license that does not require providing source code, then Debian
would be permitted to distribute it in non-free.

This issue is completely separate from whether the firmware has source
code according to the DFSG.

As a practical matter, only certain very old revisions of the hardware
actually need the firmware at all for basic functionality.  Most
hardware using the tg3 driver (like my laptop) are completely functional
without any firmware at all.  Certain extra features, like TCP Segment
Offloading (TSO), are enabled by the firmware, but these features are
not required for basic functionality.

-- 
brian m. carlson / brian with sandals: Houston, Texas, US
+1 713 440 7475 | http://crustytoothpaste.ath.cx/~bmc | My opinion only
troff on top of XML: http://crustytoothpaste.ath.cx/~bmc/code/thwack
OpenPGP: RSA v4 4096b 88AC E9B2 9196 305B A994 7552 F1BA 225C 0223 B187
[signature.asc (application/pgp-signature, inline)]

Information forwarded to debian-bugs-dist@lists.debian.org, <wnpp@debian.org>, "robert s. edmonds" <edmonds@debian.org>:
Bug#446028; Package wnpp. (Thu, 09 Apr 2009 21:09:02 GMT) Full text and rfc822 format available.

Acknowledgement sent to Neil Williams <codehelp@debian.org>:
Extra info received and forwarded to list. Copy sent to <wnpp@debian.org>, "robert s. edmonds" <edmonds@debian.org>. (Thu, 09 Apr 2009 21:09:02 GMT) Full text and rfc822 format available.

Message #52 received at 446028@bugs.debian.org (full text, mbox):

From: Neil Williams <codehelp@debian.org>
To: "brian m. carlson" <sandals@crustytoothpaste.ath.cx>
Cc: debian-devel@lists.debian.org, 446028@bugs.debian.org, debian-legal@lists.debian.org
Subject: Re: tg3 firmware - was (Fw: [CASE#221365]: Closed - need firmware files)
Date: Thu, 9 Apr 2009 22:06:55 +0100
[Message part 1 (text/plain, inline)]
On Thu, 9 Apr 2009 20:41:12 +0000
"brian m. carlson" <sandals@crustytoothpaste.ath.cx> wrote:

> [CC'd -legal as well; you probably want to follow up there.]
> 
> On Thu, Apr 09, 2009 at 05:46:58PM +0200, Daniel Knabl wrote:
> >Seems to me that Broadcom Inc. does really allow Debian to
> >re-distribute the included firmware explicitly.
> 
> The GPLv2 requires that distributors provide source code in certain
> circumstances.  Source code is defined in the GPLv2 as the preferred
> form for modification.  Unless Broadcom uses a hex editor to modify the
> firmware, Debian does not have the source code (the preferred form for
> modification) and therefore cannot provide it upon request.  Since
> Debian cannot comply with the license, it is not permitted to distribute
> it at all.  Doing so would be copyright infringement.

That wasn't the result of the GR:

Option 5 "Assume blobs comply with GPL unless proven otherwise"

http://www.uk.debian.org/vote/2008/vote_003

Do we know if there is "source code" for this firmware. There is no
proof that the firmware does not comply with the GPLv2 AFAICT,
therefore the GR requires that we assume that the firmware does
comply, whatever that means with regard to the "preferred form for
modification". Why assume that using a hex editor is impossible?

> This issue is completely separate from whether the firmware has source
> code according to the DFSG.

How can it be separate? The assertion from your reply was that there
was source code behind the hex. Is there *evidence* and *proof* that
this is the case?

-- 


Neil Williams
=============
http://www.data-freedom.org/
http://www.linux.codehelp.co.uk/
http://e-mail.is-not-s.ms/

[Message part 2 (application/pgp-signature, inline)]

Information forwarded to debian-bugs-dist@lists.debian.org, <wnpp@debian.org>, "robert s. edmonds" <edmonds@debian.org>:
Bug#446028; Package wnpp. (Thu, 09 Apr 2009 22:36:02 GMT) Full text and rfc822 format available.

Acknowledgement sent to "brian m. carlson" <sandals@crustytoothpaste.ath.cx>:
Extra info received and forwarded to list. Copy sent to <wnpp@debian.org>, "robert s. edmonds" <edmonds@debian.org>. (Thu, 09 Apr 2009 22:36:03 GMT) Full text and rfc822 format available.

Message #57 received at 446028@bugs.debian.org (full text, mbox):

From: "brian m. carlson" <sandals@crustytoothpaste.ath.cx>
To: debian-devel@lists.debian.org, debian-legal@lists.debian.org, 446028@bugs.debian.org
Subject: Re: tg3 firmware - was (Fw: [CASE#221365]: Closed - need firmware files)
Date: Thu, 9 Apr 2009 22:34:15 +0000
[Message part 1 (text/plain, inline)]
On Thu, Apr 09, 2009 at 10:06:55PM +0100, Neil Williams wrote:
>On Thu, 9 Apr 2009 20:41:12 +0000
>"brian m. carlson" <sandals@crustytoothpaste.ath.cx> wrote:
>
>> [CC'd -legal as well; you probably want to follow up there.]

I don't need to be CC'd, thanks.  M-F-T set accordingly.

>> On Thu, Apr 09, 2009 at 05:46:58PM +0200, Daniel Knabl wrote:
>> >Seems to me that Broadcom Inc. does really allow Debian to
>> >re-distribute the included firmware explicitly.
>> 
>> The GPLv2 requires that distributors provide source code in certain
>> circumstances.  Source code is defined in the GPLv2 as the preferred
>> form for modification.  Unless Broadcom uses a hex editor to modify the
>> firmware, Debian does not have the source code (the preferred form for
>> modification) and therefore cannot provide it upon request.  Since
>> Debian cannot comply with the license, it is not permitted to distribute
>> it at all.  Doing so would be copyright infringement.
>
>That wasn't the result of the GR:
>
>Option 5 "Assume blobs comply with GPL unless proven otherwise"

I'm going to ignore for the moment the fact that this title has a
negligible relation to the proposal's content and that the actual
proposal supports my point.

There are two issues here:

* Broadcom says that the entire driver (presumably including firmware) is
  GPLv2.  Because we know that it is not shipped with source code (see
  below), we know that this is insufficient to make the firmware
  legally distributable.
* The firmware actually has a separate license that reads as follows:

   * Firmware is:
   *	Derived from proprietary unpublished source code,
   *	Copyright (C) 2000-2003 Broadcom Corporation.
   *
   *	Permission is hereby granted for the distribution of this firmware
   *	data in hexadecimal or equivalent format, provided this copyright
   *	notice is accompanying it.

  This license does not allow for modification.  Therefore, Debian can
  legally distribute the firmware, but only in non-free.  I have no
  objection to Debian distributing this firmware in non-free;
  nevertheless, as I stated in my original post, whether Debian
  distributes this firmware is mostly irrelevant with regard to having a
  functioning tg3 driver.

>Do we know if there is "source code" for this firmware. There is no
>proof that the firmware does not comply with the GPLv2 AFAICT,
>therefore the GR requires that we assume that the firmware does
>comply, whatever that means with regard to the "preferred form for
>modification". Why assume that using a hex editor is impossible?

I'm not saying that using a hex editor is impossible.  I'm saying that
there's source code:

   * Firmware is:
   *	Derived from proprietary unpublished source code,
   *	Copyright (C) 2000-2003 Broadcom Corporation.

I don't know about you, but I'd much prefer to modify any sort of
program, firmware or not, using C or assembly rather than editing the
binary directly.  I suspect that this is the case for any reasonable
programmer.  Thus, we do not have the preferred form for modification,
and thus, we cannot distribute it under the GPLv2.

>> This issue is completely separate from whether the firmware has source
>> code according to the DFSG.
>
>How can it be separate? The assertion from your reply was that there
>was source code behind the hex. Is there *evidence* and *proof* that
>this is the case?

Yes.  Why would Broadcom lie about there being source code?

-- 
brian m. carlson / brian with sandals: Houston, Texas, US
+1 713 440 7475 | http://crustytoothpaste.ath.cx/~bmc | My opinion only
troff on top of XML: http://crustytoothpaste.ath.cx/~bmc/code/thwack
OpenPGP: RSA v4 4096b 88AC E9B2 9196 305B A994 7552 F1BA 225C 0223 B187
[signature.asc (application/pgp-signature, inline)]

Information forwarded to debian-bugs-dist@lists.debian.org, <wnpp@debian.org>, "robert s. edmonds" <edmonds@debian.org>:
Bug#446028; Package wnpp. (Fri, 10 Apr 2009 01:36:02 GMT) Full text and rfc822 format available.

Acknowledgement sent to md@Linux.IT (Marco d'Itri):
Extra info received and forwarded to list. Copy sent to <wnpp@debian.org>, "robert s. edmonds" <edmonds@debian.org>. (Fri, 10 Apr 2009 01:36:02 GMT) Full text and rfc822 format available.

Message #62 received at 446028@bugs.debian.org (full text, mbox):

From: md@Linux.IT (Marco d'Itri)
To: debian-devel@lists.debian.org, debian-legal@lists.debian.org, 446028@bugs.debian.org
Subject: Re: tg3 firmware - was (Fw: [CASE#221365]: Closed - need firmware files)
Date: Fri, 10 Apr 2009 03:32:15 +0200
[Message part 1 (text/plain, inline)]
On Apr 10, "brian m. carlson" <sandals@crustytoothpaste.ath.cx> wrote:

> I don't know about you, but I'd much prefer to modify any sort of
> program, firmware or not, using C or assembly rather than editing the
> binary directly.  I suspect that this is the case for any reasonable
> programmer.  Thus, we do not have the preferred form for modification,
> and thus, we cannot distribute it under the GPLv2.
Thank you for the great work you are doing to improve Debian.

-- 
ciao,
Marco
[signature.asc (application/pgp-signature, inline)]

Information forwarded to debian-bugs-dist@lists.debian.org, <wnpp@debian.org>, "robert s. edmonds" <edmonds@debian.org>:
Bug#446028; Package wnpp. (Fri, 10 Apr 2009 01:42:02 GMT) Full text and rfc822 format available.

Acknowledgement sent to Ben Hutchings <ben@decadent.org.uk>:
Extra info received and forwarded to list. Copy sent to <wnpp@debian.org>, "robert s. edmonds" <edmonds@debian.org>. (Fri, 10 Apr 2009 01:42:02 GMT) Full text and rfc822 format available.

Message #67 received at 446028@bugs.debian.org (full text, mbox):

From: Ben Hutchings <ben@decadent.org.uk>
To: Marco d'Itri <md@Linux.IT>
Cc: debian-devel@lists.debian.org, debian-legal@lists.debian.org, 446028@bugs.debian.org
Subject: Re: tg3 firmware - was (Fw: [CASE#221365]: Closed - need firmware files)
Date: Fri, 10 Apr 2009 02:39:04 +0100
[Message part 1 (text/plain, inline)]
On Fri, 2009-04-10 at 03:32 +0200, Marco d'Itri wrote:
> On Apr 10, "brian m. carlson" <sandals@crustytoothpaste.ath.cx> wrote:
> 
> > I don't know about you, but I'd much prefer to modify any sort of
> > program, firmware or not, using C or assembly rather than editing the
> > binary directly.  I suspect that this is the case for any reasonable
> > programmer.  Thus, we do not have the preferred form for modification,
> > and thus, we cannot distribute it under the GPLv2.
> Thank you for the great work you are doing to improve Debian.

Brian is right; binary-only firmware generally can't be distributed
under GPLv2.  I forget what the status of tg3 is but Michael Chan of
Broadcom has worked with us on separating bnx2 and bnx2x firmware under
an appropriate licence, so I expect it will be possible to fix any
remaining problems with tg3 firmware licencing.  You are doing nothing
but insulting people who point out the legal and ethical issues with
embedded firmware blobs, and that certainly doesn't improve Debian.

Ben.

[signature.asc (application/pgp-signature, inline)]

Information forwarded to debian-bugs-dist@lists.debian.org, <wnpp@debian.org>, "robert s. edmonds" <edmonds@debian.org>:
Bug#446028; Package wnpp. (Fri, 10 Apr 2009 08:18:02 GMT) Full text and rfc822 format available.

Acknowledgement sent to Neil Williams <codehelp@debian.org>:
Extra info received and forwarded to list. Copy sent to <wnpp@debian.org>, "robert s. edmonds" <edmonds@debian.org>. (Fri, 10 Apr 2009 08:18:03 GMT) Full text and rfc822 format available.

Message #72 received at 446028@bugs.debian.org (full text, mbox):

From: Neil Williams <codehelp@debian.org>
To: debian-devel@lists.debian.org, debian-legal@lists.debian.org, 446028@bugs.debian.org
Subject: Re: tg3 firmware - was (Fw: [CASE#221365]: Closed - need firmware files)
Date: Fri, 10 Apr 2009 09:14:49 +0100
[Message part 1 (text/plain, inline)]
On Thu, 9 Apr 2009 22:34:15 +0000
"brian m. carlson" <sandals@crustytoothpaste.ath.cx> wrote:

> * The firmware actually has a separate license that reads as follows:
> 
>     * Firmware is:
>     *	Derived from proprietary unpublished source code,

OK, I wasn't aware of that. With the clear statement that source code
was involved in the derivation of the firmware, I'd agree that the
effect of the GR is that this firmware needs source code to be in main.

>     *	Copyright (C) 2000-2003 Broadcom Corporation.
>     *
>     *	Permission is hereby granted for the distribution of this firmware
>     *	data in hexadecimal or equivalent format, provided this copyright
>     *	notice is accompanying it.
> 
>    This license does not allow for modification.  Therefore, Debian can
>    legally distribute the firmware, but only in non-free.  I have no
>    objection to Debian distributing this firmware in non-free;
>    nevertheless, as I stated in my original post, whether Debian
>    distributes this firmware is mostly irrelevant with regard to having a
>    functioning tg3 driver.
> 
> I don't know about you, but I'd much prefer to modify any sort of
> program, firmware or not, using C or assembly rather than editing the
> binary directly.  I suspect that this is the case for any reasonable
> programmer. 

I still hanker after the days of tweaking things in the assembly or
hacking around in a compiled binary with a hex editor. As long as
source code exists, the effort required becomes a pointless diversion
but there remain instances where binary constructs are not compiled,
they are created by test and experimentation according to the design
(and more often the errata) of a particular piece of hardware using
electrical equipment or hardware tools, not text editors. As such, not
all firmware can be expected to have any source code. In this case, as
we have a declaration that source code was involved, that doesn't apply
here.

-- 


Neil Williams
=============
http://www.data-freedom.org/
http://www.nosoftwarepatents.com/
http://www.linux.codehelp.co.uk/

[Message part 2 (application/pgp-signature, inline)]

Information forwarded to debian-bugs-dist@lists.debian.org, <wnpp@debian.org>, "robert s. edmonds" <edmonds@debian.org>:
Bug#446028; Package wnpp. (Fri, 10 Apr 2009 17:39:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to Jeff Carr <basilarchia@gmail.com>:
Extra info received and forwarded to list. Copy sent to <wnpp@debian.org>, "robert s. edmonds" <edmonds@debian.org>. (Fri, 10 Apr 2009 17:39:03 GMT) Full text and rfc822 format available.

Message #77 received at 446028@bugs.debian.org (full text, mbox):

From: Jeff Carr <basilarchia@gmail.com>
To: Neil Williams <codehelp@debian.org>
Cc: debian-devel@lists.debian.org, debian-legal@lists.debian.org, 446028@bugs.debian.org
Subject: Re: tg3 firmware - was (Fw: [CASE#221365]: Closed - need firmware files)
Date: Fri, 10 Apr 2009 10:36:13 -0700
On Fri, Apr 10, 2009 at 01:14, Neil Williams <codehelp@debian.org> wrote:

>>     * Firmware is:
>>     * Derived from proprietary unpublished source code,

> electrical equipment or hardware tools, not text editors. As such, not
> all firmware can be expected to have any source code. In this case, as
> we have a declaration that source code was involved, that doesn't apply
> here.

Those tools often have source code like verilog or vhdl, but that
doesn't change the problem that this blob can be put into any
recognizable form. I wouldn't rule it out is the statement seems to
imply that. It says derived from not compiled from. Even the person
that made it may not know.




Information forwarded to debian-bugs-dist@lists.debian.org, wnpp@debian.org, "robert s. edmonds" <edmonds@debian.org>:
Bug#446028; Package wnpp. (Tue, 25 May 2010 17:22:33 GMT) Full text and rfc822 format available.

Acknowledgement sent to Lucas Nussbaum <lucas@debian.org>:
Extra info received and forwarded to list. Copy sent to wnpp@debian.org, "robert s. edmonds" <edmonds@debian.org>. (Tue, 25 May 2010 17:22:33 GMT) Full text and rfc822 format available.

Message #82 received at 446028@bugs.debian.org (full text, mbox):

From: Lucas Nussbaum <lucas@debian.org>
To: 446028@bugs.debian.org
Cc: control@bugs.debian.org
Subject: tg3dfsg: changing back from ITP to RFP
Date: Tue, 25 May 2010 17:06:09 +0000
retitle 446028 RFP: tg3dfsg -- firmware free Broadcom Tigon3 network driver
noowner 446028
thanks

Hi,

This is an automatic email to change the status of tg3dfsg back from ITP
(Intent to Package) to RFP (Request for Package), because this bug hasn't seen
any activity during the last 12 months.

If you are still interested in adopting tg3dfsg, please send a mail to
<control@bugs.debian.org> with:

 retitle 446028 ITP: tg3dfsg -- firmware free Broadcom Tigon3 network driver
 owner 446028 !
 thanks

However, it is not recommended to keep ITP for a long time without acting on
the package, as it might cause other prospective maintainers to refrain from
packaging that software. It is also a good idea to document your progress on
this ITP from time to time, by mailing <446028@bugs.debian.org>.

Thank you for your interest in Debian,
-- 
Lucas, for the QA team <debian-qa@lists.debian.org>




Changed Bug title to 'RFP: tg3dfsg -- firmware free Broadcom Tigon3 network driver' from 'ITP: tg3dfsg -- firmware free Broadcom Tigon3 network driver' Request was from Lucas Nussbaum <lucas@debian.org> to control@bugs.debian.org. (Tue, 25 May 2010 17:27:17 GMT) Full text and rfc822 format available.

Removed annotation that Bug was owned by "robert s. edmonds" <edmonds@debian.org>. Request was from Lucas Nussbaum <lucas@debian.org> to control@bugs.debian.org. (Tue, 25 May 2010 17:27:18 GMT) Full text and rfc822 format available.

Send a report that this bug log contains spam.


Debian bug tracking system administrator <owner@bugs.debian.org>. Last modified: Sat Apr 19 19:11:52 2014; Machine Name: buxtehude.debian.org

Debian Bug tracking system
Copyright (C) 1999 Darren O. Benham, 1997,2003 nCipher Corporation Ltd, 1994-97 Ian Jackson.